using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Petzold.Xna3D
{
    public class Pin
    {
        Disk disk;
        Cylinder cylinder;
        Cone cone;

        public Pin(GraphicsDevice graphicsDevice, float radius, float baseLength, float pointLength, int slices, Color clr, Matrix matrix)
        {
            disk = new Disk(graphicsDevice, radius, slices, clr, matrix);
            cylinder = new Cylinder(graphicsDevice, radius, baseLength, slices, clr, matrix);
            cone = new Cone(graphicsDevice, radius, pointLength, slices, clr, Matrix.CreateTranslation(0, baseLength, 0) * matrix);
        }

        public void Draw()
        {
            disk.Draw();
            cylinder.Draw();
            cone.Draw();
        }
    }
}
