﻿using System;
using System.Windows.Navigation;
using Microsoft.Devices.Sensors;
using Microsoft.Phone.Controls;

namespace ArrowCompass
{
    public partial class MainPage : PhoneApplicationPage
    {
        Compass compass;

        public MainPage()
        {
            InitializeComponent();

            if (Compass.IsSupported)
            {
                compass = new Compass();
                compass.TimeBetweenUpdates = TimeSpan.FromMilliseconds(33);
                compass.CurrentValueChanged += OnCompassCurrentValueChanged;
            }
        }

        protected override void OnNavigatedTo(NavigationEventArgs args)
        {
            if (compass != null)
            {
                try { compass.Start(); }
                catch { }
            }
            base.OnNavigatedTo(args);
        }

        protected override void OnNavigatedFrom(NavigationEventArgs e)
        {
            if (compass != null)
                compass.Stop();

            base.OnNavigatedFrom(e);
        }

        void OnCompassCurrentValueChanged(object sender, SensorReadingEventArgs<CompassReading> args)
        {
            this.Dispatcher.BeginInvoke(() =>
            {
                arrowRotate.Angle = -args.SensorReading.TrueHeading;
                accuracyText.Text = String.Format("±{0}°", args.SensorReading.HeadingAccuracy);
            });
        }
    }
}